<!--
  ~ EVS Client is part of the Gazelle Test Bed
  ~ Copyright (C) 2006-2016 IHE
  ~ mailto :eric DOT poiseau AT inria DOT fr
  ~
  ~ See the NOTICE file distributed with this work for additional information
  ~ regarding copyright ownership.  This code is licensed
  ~ to you under the Apache License, Version 2.0 (the
  ~ "License"); you may not use this file except in compliance
  ~ with the License.  You may obtain a copy of the License at
  ~
  ~   http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing,
  ~ software distributed under the License is distributed on an
  ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~ KIND, either express or implied.  See the License for the
  ~ specific language governing permissions and limitations
  ~ under the License.
  -->

<ui:composition xmlns:h="http://java.sun.com/jsf/html" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle"
                xmlns:rich="http://richfaces.org/rich"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns="http://www.w3.org/1999/xhtml">
    <ui:param name="gui" value="#{validationResultBeanGui}"/>
    <s:div id="validationResultPanel" rendered="#{gui.getSelectedObject() != null}">
        #{gui.init(validationBeanGui.buildAndGetValidationResultDto(), validationBeanGui.referencedStandard.id)}

        <!-- general information -->

        <ui:decorate template="/layout/panels/_panel_title_footer_id.xhtml">
            <ui:define name="panel_title">
                <ui:include src="/common/informationHeader.xhtml">
                    <ui:param name="resultGui" value="#{gui}"/>
                    <ui:param name="idToRender" value="generalInfoPanel"/>
                </ui:include>
            </ui:define>
            <ui:param name="panel_id" value="generalInfoPanel"/>

            <dl class="dl-horizontal">

                <dt class="#{dt_styleClass}">
                    #{messages['gazelle.evs.client.cda.filename']}
                </dt>
                <dd class="#{dd_styleClass}">
                    <h:outputText value="#{gui.selectedObject.object.originalFileName}"/>
                    <h:commandLink action="#{gui.downloadValidatedObject()}">
                        <s:span title="#{messages['gazelle.evs.DownloadFile']}"
                                styleClass="gzl-icon-download text-info"/>
                    </h:commandLink>
                </dd>

                <dt class="#{dt_styleClass}">
                    #{messages['gazelle.evs.client.cda.oid']} :
                </dt>
                <dd class="#{dd_styleClass}">
                    <h:outputText value="#{gui.selectedObject.oid}"/>
                </dd>

                <dt class="#{dt_styleClass}">
                    #{messages['gazelle.evs.client.validation.date']} :
                </dt>
                <dd class="#{dd_styleClass}">
                    <g:date date="true" time="true"
                            value="#{gui.selectedObject.date}" tooltip="false"/>
                </dd>

                <dt title="#{gui.getValidationServiceName()}" class="#{dt_styleClass}">
                    <h:outputText value="#{gui.getValidationServiceName()}"/>
                    <h:outputText
                            value=" (#{gui.getValidationServiceVersion()})"
                            rendered="#{gui.getValidationServiceVersion() != null}"/>
                </dt>
                <dd class="#{dd_styleClass}">
                    <h:outputText value="#{gui.getValidatorName()}"/>
                    <h:outputText
                            value=" (#{gui.getValidationProfileVersion()})"
                            rendered="#{gui.getValidationProfileVersion() != null}"/>
                </dd>

                <dt class="#{dt_styleClass}">
                    <h:outputText value="#{messages['net.ihe.gazelle.evsclient.ValidationResults']} :"/>
                </dt>
                <dd class="#{dd_styleClass}">
                    <h:outputText
                            styleClass="#{gui.getValidationStatus() == 'VALIDATION NOT PERFORMED'? 'gzl-label gzl-label-grey' : gui.getValidationStatus()}"
                            value="#{gui.getValidationStatus()}"/>
                    <h:commandLink action="#{gui.downloadResultAsXml()}"
                                   rendered="#{gui.originalReportDownloadable}" execute="@form">
                        <s:span title="#{messages['net.ihe.gazelle.EVSClient-ui.DownloadValidationResultsXML']})"
                                styleClass="gzl-icon-download text-info"/>
                    </h:commandLink>
                    <h:commandLink action="#{gui.downloadReportAsPdf()}"
                                   rendered="#{gui.getValidatorName() != null and gui.showStyledReport() == true}">
                        <s:span title="#{messages['net.ihe.gazelle.EVSClient-ui.DownloadValidationResultsPDF']})"
                                styleClass="gzl-icon-pdf"/>
                    </h:commandLink>


                </dd>

                <!-- Additional information if there was an extension call has been done-->
                <s:div>
                    <ui:include src="/common/_infoPanelsOfExtensions.xhtml">
                        <ui:param name="validation" value="#{gui.selectedObject}"/>
                    </ui:include>
                </s:div>

                <dt class="#{dt_styleClass}">
                    #{messages['gazelle.evs.client.Permanent.Link']} :
                </dt>
                <dd class="#{dd_styleClass}">
                    <h:outputLink value="#{gui.getPermanentLink(gui.selectedObject)}"
                                  target="_blank">
                        <h:outputText value="#{gui.getPermanentLink(gui.selectedObject)}"/>
                    </h:outputLink>
                </dd>
                <dt class="#{dt_styleClass}">
                    #{messages['net.ihe.gazelle.evsclient.DataVisibility']}
                </dt>
                <dd class="#{dd_styleClass}" id="nameInput">
                    <h:outputText rendered="#{!gui.selectedObject.sharing.isPrivate}"
                                  value="#{messages['net.ihe.gazelle.evsclient.Public']}"/>
                    <h:outputText
                            rendered="#{gui.selectedObject.sharing.isPrivate
                                        and gui.selectedObject.sharing.privacyKey == null}"
                            value="#{messages['net.ihe.gazelle.evsclient.Private']}"/>
                    <h:outputText rendered="#{gui.selectedObject.privacyKey != null}"
                                  value="#{messages['net.ihe.gazelle.EVSClient-ui.Shared']}"/>
                    <h:outputText
                            rendered="#{identity.loggedIn and not empty gui.selectedObject.owner.username}"
                            value=" - #{messages['net.ihe.gazelle.evsclient.OwnedBy']} #{gui.getUserName(gui.selectedObject.owner.username)} / #{gui.selectedObject.owner.organization}"/>
                </dd>
            </dl>

            <ui:define name="panel_footer">
                <ui:include src="/common/informationFooter.xhtml">
                    <ui:param name="resultGui" value="#{gui}"/>
                    <ui:param name="idToRender" value="generalInfoPanel"/>
                </ui:include>

            </ui:define>
        </ui:decorate>

        <rich:tabPanel id="validationResultsPanel" withBorder="true" switchType="ajax" activeItem="default">
            <rich:tab id="default" name="default" header="#{messages['net.ihe.gazelle.evsclient.ValidationResults']}">
                <s:div rendered="#{gui.selectedObject.validationService != null and gui.detailedResult!=null}">
                    <!--                    <ui:decorate template="/common/_detailedResult.xhtml">
                                            <ui:param name="reporter" value="#{gui.reporter}"/>
                                            <ui:param name="servicename" value="#{gui.selectedObject.validationService.name}"/>
                                        </ui:decorate>
                                        -->
                </s:div>
                <!--                <s:div rendered="#{gui.selectedObject.validationService != null and gui.detailedResult==null and gui.selectedObject.validationReport != null}">-->
                <s:div rendered="#{gui.selectedObject.validationService != null and gui.selectedObject.validationReport != null}">
                    <ui:decorate template="/common/_report.xhtml">
                        <ui:param name="reporter" value="#{gui.reporter}"/>
                        <ui:param name="servicename" value="#{gui.selectedObject.validationService.name}"/>
                        <ui:param name="prettyView" value="#{validationBeanGui.isPrettyViewEnabled()}"/>
                    </ui:decorate>
                </s:div>
            </rich:tab>

            <!-- Extensions -->
            <ui:decorate template="/common/_extensionsTabs.xhtml">
                <ui:param name="resultGui" value="#{gui}"/>
            </ui:decorate>

        </rich:tabPanel>
        <br/>
        <ui:decorate template="/layout/panels/_panel_title_id.xhtml">
            <ui:param name="panel_id" value="fileContentPanel"/>

            <ui:define name="panel_title">
                <h:outputText value="#{messages['net.ihe.gazelle.evs.FileContent']}"/>
            </ui:define>

            <s:div rendered="#{gui.isDocumentTooLarge()}">
                <h:form id="formContent">
                    <rich:togglePanel id="panelContentXml" render="tabs" activeItem="panelItemMessage"
                                      itemChangeListener="#{gui.updateCurrent()}">
                        <rich:togglePanelItem name="panelItemMessage">
                            <a4j:outputPanel layout="block" rendered="true" id="fileContentMessage">
                                <span class="gzl-icon-times"/>
                                <h:outputText
                                        value="#{messages['net.ihe.gazelle.EVSClient-ui.FileTooBig']} (#{messages['net.ihe.gazelle.EVSClient-ui.ContentSize']} : #{gui.getDocumentSize()} #{messages['net.ihe.gazelle.evs.Mb']})"/>
                            </a4j:outputPanel>
                        </rich:togglePanelItem>
                        <rich:togglePanelItem name="panelItemContent">
                            <h:panelGroup id="panelContent">
                                <ui:include src="_fileContent.xhtml"/>
                            </h:panelGroup>
                        </rich:togglePanelItem>
                    </rich:togglePanel>
                    <a4j:outputPanel id="tabs" layout="block">
                        <br/>
                        <a4j:outputPanel layout="block" styleClass="gzl-btn-red btn-danger"
                                         rendered="#{rich:findComponent('panelContentXml').activeItem != 'panelItemContent'}">
                            <rich:toggleControl event="click" targetPanel="panelContentXml"
                                                targetItem="panelItemContent"/>
                            <h:outputText value="#{messages['net.ihe.gazelle.EVSClient-ui.RenderBigFile']}"/>
                        </a4j:outputPanel>
                    </a4j:outputPanel>
                </h:form>
            </s:div>
            <br/>
            <s:div rendered="#{not gui.isDocumentTooLarge()}">
                <!-- file content -->
                <h:panelGroup id="fileContent">
                    <ui:include src="_fileContent.xhtml"/>
                </h:panelGroup>
            </s:div>
        </ui:decorate>
    </s:div>

    <s:div id="badid" rendered="#{gui.selectedObject == null}">
        <ui:decorate template="/layout/panels/_panel_title_id.xhtml">
            <ui:param name="panel_id" value="badidPanel"/>
            <ui:define name="panel_title">
                <h:outputText value="#{messages['gazelle.evs.client.cda.unknown.id']}"/>
            </ui:define>
            #{messages['net.ihe.gazelle.EVSClient-ui.CouldNotFindAnObjectInTheDatabaseCorrespondingTo']}
        </ui:decorate>
    </s:div>

    <ui:include src="/common/sendToProxyPanel4XmlBasedFiles.xhtml">
        <ui:param name="managedBean" value="#{gui}"/>
    </ui:include>
</ui:composition>